Index: /trunk/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- /trunk/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 5548)
+++ /trunk/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 5604)
@@ -2531,717 +2531,500 @@
 	}
 	
-	function send_mail($params)
-	{
-		require_once dirname(__FILE__) . '/../../services/class.servicelocator.php';
-		$mailService = ServiceLocator::getService('mail');
-
-		include_once("class.db_functions.inc.php");
-		$db = new db_functions();
-		$fromaddress = $params['input_from'] ? explode(';',$params['input_from']) : "";
-		$message_attachments_contents = (isset($params['message_attachments_content'])) ? $params['message_attachments_content'] : false; 
-		
-		##
-		# @AUTHOR Rodrigo Souza dos Santos
-		# @DATE 2008/09/17$fileName
-		# @BRIEF Checks if the user has permission to send an email with the email address used.
-		##
-		if ( is_array($fromaddress) && ($fromaddress[1] != $_SESSION['phpgw_info']['expressomail']['user']['email']) )
-		{
-			$deny = true;
-			foreach( $_SESSION['phpgw_info']['expressomail']['user']['shared_mailboxes'] as $key => $val )
-				if ( array_key_exists('mail', $val) && $val['mail'][0] == $fromaddress[1] )
-					$deny = false and end($_SESSION['phpgw_info']['expressomail']['user']['shared_mailboxes']);
-
-			if ( $deny )
-				return "The server denied your request to send a mail, you cannot use this mail address.";
-		}	    
-
-		$toaddress = $db->getAddrs(explode(',',$params['input_to']));//implode(',',);
-		$ccaddress = $db->getAddrs(explode(',',$params['input_cc']));//implode(',',);
-		$ccoaddress = $db->getAddrs(explode(',',$params['input_cco']));//implode(',',); 
-
-		if($toaddress["False"] || $ccaddress["False"] || $ccoaddress["False"]){
-			return $this->parse_error("Invalid Mail:", ($toaddress["False"] ? $toaddress["False"] : ($ccaddress["False"] ? $ccaddress["False"] : $ccoaddress["False"])));
-		}
-		
-		$toaddress = implode(',', $toaddress);
-		$ccaddress = implode(',', $ccaddress);
-		$ccoaddress = implode(',', $ccoaddress);
-		
-		if($toaddress == "" && $ccaddress == "" && $ccoaddress == ""){
-			return $this->parse_error("Invalid Mail:", ($params['input_to'] ? $params['input_to'] :($params['input_cc'] ? $params['input_cc'] : $params['input_cco'])) );
-		}
-
-		$toaddress  = preg_replace('/<\s+/', '<', $toaddress);			
-		$toaddress  = preg_replace('/\s+>/', '>', $toaddress);
-			
-		$ccaddress  = preg_replace('/<\s+/', '<', $ccaddress);
-		$ccaddress  = preg_replace('/\s+>/', '>', $ccaddress);
-		
-		$ccoaddress = preg_replace('/<\s+/', '<', $ccoaddress);
-		$ccoaddress = preg_replace('/\s+>/', '>', $ccoaddress);
-		
-		$replytoaddress = $params['input_replyto'];
-		$subject = $params['input_subject'];
-		$msg_uid = $params['msg_id'];
-		$return_receipt = $params['input_return_receipt'];
-		$is_important = $params['input_important_message'];
-        $encrypt = $params['input_return_cripto'];
-		$signed = $params['input_return_digital'];
-
-		$message_attachments = $params['message_attachments'];
-                 
-                if(substr($params['input_to'],-1) == ',')
-                    $params['input_to'] = substr($params['input_to'],0,-1);
-
-                if(substr($params['input_cc'],-1) == ',')
-                    $params['input_cc'] = substr($params['input_cc'],0,-1);
-
-                if(substr($params['input_cco'],-1) == ',')
-                    $params['input_cco'] = substr($params['input_cco'],0,-1);
-
-                // Valida numero Maximo de Destinatarios 
-                if($_SESSION['phpgw_info']['expresso']['expressoMail']['expressoAdmin_maximum_recipients'] > 0) 
-                { 
-                    $sendersNumber = count(explode(',',$params['input_to'])); 
-
-                    if($params['input_cc']) 
-                        $sendersNumber +=  count(explode(',',$params['input_cc'])); 
-                    if($params['input_cco']) 
-                        $sendersNumber +=  count(explode(',',$params['input_cco'])); 
-
-                    $userMaxmimumSenders = $db->getMaximumRecipientsUser($this->username); 
-                    if($userMaxmimumSenders) 
-                    { 
-                        if($sendersNumber > $userMaxmimumSenders) 
-                            return $this->functions->getLang('Number of recipients greater than allowed'); 
-                    } 
-                    else 
-                    { 
-                        $ldap = new ldap_functions(); 
-                        $groupsToUser = $ldap->get_user_groups($this->username); 
-
-                        $groupMaxmimumSenders = $db->getMaximumRecipientsGroup($groupsToUser); 
-
-                        if($groupMaxmimumSenders > 0) 
-                        { 
-                            if($sendersNumber > $groupMaxmimumSenders) 
-                                return $this->functions->getLang('Number of recipients greater than allowed'); 
-                        } 
-                        else 
-                        { 
-                             if($sendersNumber > $_SESSION['phpgw_info']['expresso']['expressoMail']['expressoAdmin_maximum_recipients']) 
-                             return $this->functions->getLang('Number of recipients greater than allowed'); 
-                        } 
-                    } 
-
-                } 
-                //Fim Valida numero maximo de destinatarios 
-                
-                
-                //Valida envio de email para shared accounts
-                if($_SESSION['phpgw_info']['expresso']['expressoMail']['expressoMail_block_institutional_comunication'] == 'true')
-                {
+	function send_mail($params) {               
+
+            require_once dirname(__FILE__) . '/../../services/class.servicelocator.php';
+            require_once dirname(__FILE__) . '/../../prototype/api/controller.php';
+            $mailService = ServiceLocator::getService('mail');
+
+            include_once("class.db_functions.inc.php");
+            $db = new db_functions();
+            $fromaddress = $params['input_from'] ? explode(';', $params['input_from']) : "";
+            $message_attachments_contents = (isset($params['message_attachments_content'])) ? $params['message_attachments_content'] : false;
+
+            ##
+            # @AUTHOR Rodrigo Souza dos Santos
+            # @DATE 2008/09/17$fileName
+            # @BRIEF Checks if the user has permission to send an email with the email address used.
+            ##
+            if (is_array($fromaddress) && ($fromaddress[1] != $_SESSION['phpgw_info']['expressomail']['user']['email'])) {
+                $deny = true;
+                foreach ($_SESSION['phpgw_info']['expressomail']['user']['shared_mailboxes'] as $key => $val)
+                    if (array_key_exists('mail', $val) && $val['mail'][0] == $fromaddress[1])
+                        $deny = false and end($_SESSION['phpgw_info']['expressomail']['user']['shared_mailboxes']);
+
+                if ($deny)
+                    return "The server denied your request to send a mail, you cannot use this mail address.";
+            }
+
+            $toaddress = $db->getAddrs(explode(',', $params['input_to'])); //implode(',',);
+            $ccaddress = $db->getAddrs(explode(',', $params['input_cc'])); //implode(',',);
+            $ccoaddress = $db->getAddrs(explode(',', $params['input_cco'])); //implode(',',); 
+
+            if ($toaddress["False"] || $ccaddress["False"] || $ccoaddress["False"]) {
+                return $this->parse_error("Invalid Mail:", ($toaddress["False"] ? $toaddress["False"] : ($ccaddress["False"] ? $ccaddress["False"] : $ccoaddress["False"])));
+            }
+
+            $toaddress = implode(',', $toaddress);
+            $ccaddress = implode(',', $ccaddress);
+            $ccoaddress = implode(',', $ccoaddress);
+
+            if ($toaddress == "" && $ccaddress == "" && $ccoaddress == "") {
+                return $this->parse_error("Invalid Mail:", ($params['input_to'] ? $params['input_to'] : ($params['input_cc'] ? $params['input_cc'] : $params['input_cco'])));
+            }
+
+            $toaddress = preg_replace('/<\s+/', '<', $toaddress);
+            $toaddress = preg_replace('/\s+>/', '>', $toaddress);
+
+            $ccaddress = preg_replace('/<\s+/', '<', $ccaddress);
+            $ccaddress = preg_replace('/\s+>/', '>', $ccaddress);
+
+            $ccoaddress = preg_replace('/<\s+/', '<', $ccoaddress);
+            $ccoaddress = preg_replace('/\s+>/', '>', $ccoaddress);
+
+            $replytoaddress = $params['input_replyto'];
+            $subject = $params['input_subject'];
+            $return_receipt = $params['input_return_receipt'];
+            $is_important = $params['input_important_message'];
+            $encrypt = $params['input_return_cripto'];
+            $signed = $params['input_return_digital'];
+
+            $message_attachments = $params['message_attachments'];
+
+            if (substr($params['input_to'], -1) == ',')
+                $params['input_to'] = substr($params['input_to'], 0, -1);
+
+            if (substr($params['input_cc'], -1) == ',')
+                $params['input_cc'] = substr($params['input_cc'], 0, -1);
+
+            if (substr($params['input_cco'], -1) == ',')
+                $params['input_cco'] = substr($params['input_cco'], 0, -1);
+
+            // Valida numero Maximo de Destinatarios 
+            if ($_SESSION['phpgw_info']['expresso']['expressoMail']['expressoAdmin_maximum_recipients'] > 0) {
+                $sendersNumber = count(explode(',', $params['input_to']));
+
+                if ($params['input_cc'])
+                    $sendersNumber += count(explode(',', $params['input_cc']));
+                if ($params['input_cco'])
+                    $sendersNumber += count(explode(',', $params['input_cco']));
+
+                $userMaxmimumSenders = $db->getMaximumRecipientsUser($this->username);
+                if ($userMaxmimumSenders) {
+                    if ($sendersNumber > $userMaxmimumSenders)
+                        return $this->functions->getLang('Number of recipients greater than allowed');
+                }
+                else {
                     $ldap = new ldap_functions();
-                    $arrayF = explode(';', $params['input_from']);
+                    $groupsToUser = $ldap->get_user_groups($this->username);
+
+                    $groupMaxmimumSenders = $db->getMaximumRecipientsGroup($groupsToUser);
+
+                    if ($groupMaxmimumSenders > 0) {
+                        if ($sendersNumber > $groupMaxmimumSenders)
+                            return $this->functions->getLang('Number of recipients greater than allowed');
+                    }
+                    else {
+                        if ($sendersNumber > $_SESSION['phpgw_info']['expresso']['expressoMail']['expressoAdmin_maximum_recipients'])
+                            return $this->functions->getLang('Number of recipients greater than allowed');
+                    }
+                }
+            }
+            //Fim Valida numero maximo de destinatarios 
+            //Valida envio de email para shared accounts
+            if ($_SESSION['phpgw_info']['expresso']['expressoMail']['expressoMail_block_institutional_comunication'] == 'true') {
+                $ldap = new ldap_functions();
+                $arrayF = explode(';', $params['input_from']);
+
+                /*
+                 * Verifica se o remetente n?o ? uma conta compartilhada
+                 */
+                if (!$ldap->isSharedAccountByMail($arrayF[1])) {
+                    $groupsToUser = $ldap->get_user_groups($this->username);
+                    $sharedAccounts = $ldap->returnSharedsAccounts($toaddress, $ccaddress, $ccoaddress);
 
                     /*
-                     * Verifica se o remetente n?o ? uma conta compartilhada
+                     * Pega o UID do remetente
                      */
-                    if(!$ldap->isSharedAccountByMail($arrayF[1]))
-                    {
-                        $groupsToUser = $ldap->get_user_groups($this->username);
-                        $sharedAccounts = $ldap->returnSharedsAccounts($toaddress, $ccaddress, $ccoaddress);
-
-                        /*
-                         * Pega o UID do remetente
-                         */
-                        $uidFrom = $ldap->mail2uid($arrayF[1]);
-
-                         /*
-                         * Remove a conta compartilhada caso o uid do remetente exista na conta compartilhada
-                         */
-                        foreach ($sharedAccounts as $key => $value)
-                        {
-                            if($value)
-                                 $acl = $this->getaclfrombox($value);
-
-                             if (array_key_exists($uidFrom, $acl))
-                                 unset($sharedAccounts[$key]);
-
-                        }
-
-                        /*
-                         * Caso ainda exista contas compartilhadas, verifica se existe alguma exce??o para estas contas
-                         */
-                        if(count($sharedAccounts) > 0)
-                          $accountsBlockeds = $db->validadeSharedAccounts($this->username, $groupsToUser, $sharedAccounts);
-
-                        /*
-                         * Retorna as contas compartilhadas bloqueadas
-                         */
-                        if(count($accountsBlockeds) > 0)
-                        {
-                            $return = '';
-
-                            foreach ($accountsBlockeds as $accountBlocked)
-                                $return.= $accountBlocked.', ';
-
-                             $return = substr($return,0,-2);
-
-                             return $this->functions->getLang('you are blocked  from sending mail to the following addresses').': '.$return;
+                    $uidFrom = $ldap->mail2uid($arrayF[1]);
+
+                    /*
+                     * Remove a conta compartilhada caso o uid do remetente exista na conta compartilhada
+                     */
+                    foreach ($sharedAccounts as $key => $value) {
+                        if ($value)
+                            $acl = $this->getaclfrombox($value);
+
+                        if (array_key_exists($uidFrom, $acl))
+                            unset($sharedAccounts[$key]);
+                    }
+
+                    /*
+                     * Caso ainda exista contas compartilhadas, verifica se existe alguma exce??o para estas contas
+                     */
+                    if (count($sharedAccounts) > 0)
+                        $accountsBlockeds = $db->validadeSharedAccounts($this->username, $groupsToUser, $sharedAccounts);
+
+                    /*
+                     * Retorna as contas compartilhadas bloqueadas
+                     */
+                    if (count($accountsBlockeds) > 0) {
+                        $return = '';
+
+                        foreach ($accountsBlockeds as $accountBlocked)
+                            $return.= $accountBlocked . ', ';
+
+                        $return = substr($return, 0, -2);
+
+                        return $this->functions->getLang('you are blocked  from sending mail to the following addresses') . ': ' . $return;
+                    }
+                }
+            }
+            // Fim Valida envio de email para shared accounts
+    //	    TODO - implementar tratamento SMIME no novo serviço de envio de emails e retirar o AND false abaixo
+            if ($params['smime'] AND false) {
+                $body = $params['smime'];
+                $mail->SMIME = true;
+                // A MSG assinada deve ser testada neste ponto.
+                // Testar o certificado e a integridade da msg....
+                include_once(dirname(__FILE__) . "/../../security/classes/CertificadoB.php");
+                $erros_acumulados = '';
+                $certificado = new certificadoB();
+                $validade = $certificado->verificar($body);
+                if (!$validade) {
+                    foreach ($certificado->erros_ssl as $linha_erro) {
+                        $erros_acumulados .= $linha_erro;
+                    }
+                } else {
+                    // Testa o CERTIFICADO: se o CPF  he o do usuario logado, se  pode assinar msgs e se  nao esta expirado...
+                    if ($certificado->apresentado) {
+                        if ($certificado->dados['EXPIRADO'])
+                            $erros_acumulados .='Certificado expirado.';
+                        $this->cpf = isset($GLOBALS['phpgw_info']['server']['certificado_atributo_cpf']) && $GLOBALS['phpgw_info']['server']['certificado_atributo_cpf'] != '' ? $_SESSION['phpgw_info']['expressomail']['user'][$GLOBALS['phpgw_info']['server']['certificado_atributo_cpf']] : $this->username;
+                        if ($certificado->dados['CPF'] != $this->cpf)
+                            $erros_acumulados .=' CPF no certificado diferente do logado no expresso.';
+                        if (!($certificado->dados['KEYUSAGE']['digitalSignature'] && $certificado->dados['EXTKEYUSAGE']['emailProtection']))
+                            $erros_acumulados .=' Certificado nao permite assinar mensagens.';
+                    }
+                    else {
+                        $$erros_acumulados .= 'Nao foi possivel usar o certificado para assinar a msg';
+                    }
+                }
+                if (!$erros_acumulados == '') {
+                    return $erros_acumulados;
+                }
+            } else {
+                //Compatibilização com Outlook, ao encaminhar a mensagem
+                $body = mb_ereg_replace('<!--\[', '<!-- [', $params['body']);
+            }
+
+            $attachments = $_FILES;
+            $forwarding_attachments = $params['forwarding_attachments'];
+            $local_attachments = $params['local_attachments'];
+
+            //Test if must be saved in shared folder and change if necessary
+            if ($fromaddress[2] == 'y') {
+                //build shared folder path
+                $newfolder = "user" . $this->imap_delimiter . $fromaddress[3] . $this->imap_delimiter . $this->imap_sentfolder;
+                if ($this->folder_exists($newfolder))
+                    $folder = $newfolder;
+                else
+                    $folder = $params['folder'];
+            } else {
+                $folder = $params['folder'];
+            }
+
+            $folder = mb_convert_encoding($folder, 'UTF7-IMAP', 'ISO_8859-1');
+            $folder = preg_replace('/INBOX[\/.]/i', 'INBOX' . $this->imap_delimiter, $folder);
+            $folder_name = $params['folder_name'];
+
+    //		TODO - tratar assinatura e remover o AND false
+            if ($signed && !$params['smime'] AND false) {
+                $mail->Mailer = "smime";
+                $mail->SignedBody = true;
+            }
+
+
+            if ($fromaddress)
+                $mailService->setFrom('"' . $fromaddress[0] . '" <' . $fromaddress[1] . '>');
+            else
+                $mailService->setFrom('"' . $_SESSION['phpgw_info']['expressomail']['user']['firstname'] . ' ' . $_SESSION['phpgw_info']['expressomail']['user']['lastname'] . '" <' . $_SESSION['phpgw_info']['expressomail']['user']['email'] . '>');
+
+            $bol = $this->add_recipients('to', $toaddress, $mailService);
+            if (!$bol) {
+                return $this->parse_error("Invalid Mail:", $toaddress);
+            }
+            $bol = $this->add_recipients('cc', $ccaddress, $mailService);
+            if (!$bol) {
+                return $this->parse_error("Invalid Mail:", $ccaddress);
+            }
+            $allow = $_SESSION['phpgw_info']['server']['expressomail']['allow_hidden_copy'];
+
+            if ($allow) {
+                //$mailService->addBcc($ccoaddress);
+                $bol = $this->add_recipients('cco', $ccoaddress, $mailService);
+
+                if (!$bol) {
+                    return $this->parse_error("Invalid Mail:", $ccoaddress);
+                }
+            }
+
+            //Implementação para o In-Reply-To e References				
+            $msg_numb = $params['messageNum'];
+            $msg_folder = $params['messageFolder'];
+            $this->mbox = $this->open_mbox($msg_folder);
+
+            $header = $this->get_header($msg_numb);
+            $header_ = imap_fetchheader($this->mbox, $msg_numb, FT_UID);
+            $pattern = '/^[ \t]*Disposition-Notification-To:[ ]*<?[[:alnum:]\._-]+@[[:alnum:]_-]+[\.[:alnum:]]+>?/sm';
+            if (preg_match($pattern, $header_, $fields)) {
+                if (preg_match('/[[:alnum:]\._\-]+@[[:alnum:]_\-\.]+/', $fields[0], $matches)) {
+                    $return['DispositionNotificationTo'] = "<" . $matches[0] . ">";
+                }
+            }
+
+            $message_id = $header->message_id;
+            $references = array();
+            if ($message_id != "") {
+                $mailService->addHeaderField('In-Reply-To', $message_id);
+
+                if (isset($header->references)) {
+                    array_push($references, $header->references);
+                }
+                array_push($references, $message_id);
+                $mailService->addHeaderField('References', $references);
+            }
+
+
+            $mailService->setSubject($subject);
+            $isHTML = ( (array_key_exists('type', $params) && in_array(strtolower($params['type']), array('html', 'plain')) ) ?
+                            strtolower($params['type']) != 'plain' : true );
+
+
+    //	TODO - tratar mensagem criptografada e remover o AND false abaixo
+            if (($encrypt && $signed && $params['smime']) || ($encrypt && !$signed) AND false) { // a msg deve ser enviada cifrada...
+                $email = $this->add_recipients_cert($toaddress . ',' . $ccaddress . ',' . $ccoaddress);
+                $email = explode(",", $email);
+                // Deve ser testado se foram obtidos os certificados de todos os destinatarios.
+                // Deve ser verificado um numero limite de destinatarios.
+                // Deve ser verificado se os certificados sao validos.
+                // Se uma das verificacoes falhar, nao enviar o e-mail e avisar o usuario.
+                // O array $mail->Certs_crypt soh deve ser preenchido se os certificados passarem nas verificacoes.
+                $numero_maximo = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['num_max_certs_to_cipher'];  // Este valor dever ser configurado pelo administrador do site ....
+                $erros_acumulados = "";
+                $aux_mails = array();
+                $mail_list = array();
+                if (count($email) > $numero_maximo) {
+                    $erros_acumulados .= "Excedido o numero maximo (" . $numero_maximo . ") de destinatarios para uma msg cifrada...." . chr(0x0A);
+                    return $erros_acumulados;
+                }
+                // adiciona o email do remetente. eh para cifrar a msg para ele tambem. Assim vai poder visualizar a msg na pasta enviados..
+                $email[] = $_SESSION['phpgw_info']['expressomail']['user']['email'];
+                foreach ($email as $item) {
+                    $certificate = $db->get_certificate(strtolower($item));
+                    if (!$certificate) {
+                        $erros_acumulados .= "Chamada com parametro invalido.  e-Mail nao pode ser vazio." . chr(0x0A);
+                        return $erros_acumulados;
+                    }
+
+                    if (array_key_exists("dberr1", $certificate)) {
+
+                        $erros_acumulados .= "Ocorreu um erro quando pesquisava certificados dos destinatarios para cifrar a msg." . chr(0x0A);
+                        return $erros_acumulados;
+                    }
+                    if (array_key_exists("dberr2", $certificate)) {
+                        $erros_acumulados .= $item . ' : Nao  pode cifrar a msg. Certificado nao localizado.' . chr(0x0A);
+                        //continue;
+                    }
+                    /*  Retirado este teste para evitar mensagem de erro duplicada.
+                      if (!array_key_exists("certs", $certificate))
+                      {
+                      $erros_acumulados .=  $item . ' : Nao  pode cifrar a msg. Certificado nao localizado.' . chr(0x0A);
+                      continue;
+                      }
+                     */
+                    include_once(dirname(__FILE__) . "/../../security/classes/CertificadoB.php");
+
+                    foreach ($certificate['certs'] as $registro) {
+                        $c1 = new certificadoB();
+                        $c1->certificado($registro['chave_publica']);
+                        if ($c1->apresentado) {
+                            $c2 = new Verifica_Certificado($c1->dados, $registro['chave_publica']);
+                            if (!$c1->dados['EXPIRADO'] && !$c2->revogado && $c2->status) {
+                                $aux_mails[] = $registro['chave_publica'];
+                                $mail_list[] = strtolower($item);
+                            } else {
+                                if ($c1->dados['EXPIRADO'] || $c2->revogado) {
+                                    $db->update_certificate($c1->dados['SERIALNUMBER'], $c1->dados['EMAIL'], $c1->dados['AUTHORITYKEYIDENTIFIER'], $c1->dados['EXPIRADO'], $c2->revogado);
+                                }
+
+                                $erros_acumulados .= $item . ':  ' . $c2->msgerro . chr(0x0A);
+                                foreach ($c2->erros_ssl as $linha) {
+                                    $erros_acumulados .= $linha . chr(0x0A);
+                                }
+                                $erros_acumulados .= 'Emissor: ' . $c1->dados['EMISSOR'] . chr(0x0A);
+                                $erros_acumulados .= $c1->dados['CRLDISTRIBUTIONPOINTS'] . chr(0x0A);
+                            }
+                        } else {
+                            $erros_acumulados .= $item . ' : Nao  pode cifrar a msg. Certificado invalido.' . chr(0x0A);
                         }
                     }
+                    if (!(in_array(strtolower($item), $mail_list)) && !empty($erros_acumulados)) {
+                        return $erros_acumulados;
+                    }
                 }
-                // Fim Valida envio de email para shared accounts
-                
-                
-//	    TODO - implementar tratamento SMIME no novo serviço de envio de emails e retirar o AND false abaixo
-	    if($params['smime'] AND false)
-        {
-            $body = $params['smime'];
-            $mail->SMIME = true;
-            // A MSG assinada deve ser testada neste ponto.
-            // Testar o certificado e a integridade da msg....
-            include_once(dirname( __FILE__ ) ."/../../security/classes/CertificadoB.php");
-            $erros_acumulados = '';
-            $certificado = new certificadoB();
-            $validade = $certificado->verificar($body);
-            if(!$validade)
+
+                $mail->Certs_crypt = $aux_mails;
+            }
+
+            $attachment = json_decode($params['attachments'],TRUE);
+
+            foreach ($attachment as &$value) 
             {
-                foreach($certificado->erros_ssl as $linha_erro)
+                if((int)$value > 0) //BD attachment
                 {
-                    $erros_acumulados .= $linha_erro;
+                     $att = Controller::read(array('id'=> $value , 'concept' => 'mailAttachment'));
+
+                     if($att['disposition'] == 'embedded')
+                     {
+                         $body = str_replace('"../prototype/getArchive.php?mailAttachment='.$att['id'].'"', $att['name'], $body);
+                         $mailService->addStringImage(base64_decode($att['source']), $att['type'], $att['name']);
+                     }
+                     else
+                         $mailService->addStringAttachment(base64_decode($att['source']), $att['name'], $att['type'], 'base64', isset($att['disposition']) ? $att['disposition'] :'attachment' );
+
+                     unset($att);
+                }
+                else //message attachment
+                {
+                    $value = json_decode($value, true);
+                    $sub =  $value['name'] ? $value['name'].'.eml' :'no title.eml';
+                    $mbox_stream = $this->open_mbox($value['folder']);
+                    $rawmsg = $this->getRawHeader($value['uid']) . "\r\n\r\n" . $this->getRawBody($value['uid']);
+                    $mailService->addStringAttachment($rawmsg, $sub, 'message/rfc822', '7bit', 'attachment' );
+                    $message_size_total += mb_strlen($rawmsg); //Adiciona o tamanho do anexo a variavel que controlao tamanho da msg.
+                    unset($rawmsg);
+                }
+
+            }
+
+            $message_size_total += strlen($params['body']);   /* Tamanho do corpo da mensagem. */        
+
+            ////////////////////////////////////////////////////////////////////////////////////////////////////	
+            /**
+             * Faz a validação pelo tamanho máximo de mensagem permitido para o usuário. Se o usuário não estiver em nenhuma regra, usa o tamanho padrão.
+             */
+            $default_max_size_rule = $db->get_default_max_size_rule();
+            if (!$default_max_size_rule) {
+                $default_max_size_rule = str_replace("M", "", ini_get('upload_max_filesize')) * 1024 * 1024; /* hack para não bloquear o envio de email quando não for configurado um tamanho padrão */
+            } else {
+                foreach ($default_max_size_rule as $i => $value) {
+                    $default_max_size_rule = $value['config_value'];
                 }
             }
-            else
-            {
-                // Testa o CERTIFICADO: se o CPF  he o do usuario logado, se  pode assinar msgs e se  nao esta expirado...
-                if ($certificado->apresentado)
-                {
-                    if($certificado->dados['EXPIRADO']) $erros_acumulados .='Certificado expirado.';
-                    $this->cpf = isset($GLOBALS['phpgw_info']['server']['certificado_atributo_cpf'])&&$GLOBALS['phpgw_info']['server']['certificado_atributo_cpf']!=''?$_SESSION['phpgw_info']['expressomail']['user'][$GLOBALS['phpgw_info']['server']['certificado_atributo_cpf']]:$this->username;
-                    if($certificado->dados['CPF'] != $this->cpf) $erros_acumulados .=' CPF no certificado diferente do logado no expresso.';
-                    if(!($certificado->dados['KEYUSAGE']['digitalSignature'] && $certificado->dados['EXTKEYUSAGE']['emailProtection'])) $erros_acumulados .=' Certificado nao permite assinar mensagens.';
-                }
-                else
-                {
-                    $$erros_acumulados .= 'Nao foi possivel usar o certificado para assinar a msg';
+
+            $default_max_size_rule = $default_max_size_rule * 1024 * 1024;    /* Tamanho da regra padrão, em bytes */
+            $id_user = $_SESSION['phpgw_info']['expressomail']['user']['userid'];
+
+
+            $ldap = new ldap_functions();
+            $groups_user = $ldap->get_user_groups($id_user);
+
+            $size_rule_by_group = array();
+            foreach ($groups_user as $k => $value_) {
+                $rule_in_group = $db->get_rule_by_user_in_groups($k);
+                if ($rule_in_group != "")
+                    array_push($size_rule_by_group, $rule_in_group);
+            }
+
+            $n_rule_groups = 0;
+            $maior_valor_regra_grupo = 0;
+            foreach ($size_rule_by_group as $i => $value) {
+                if (is_array($value[0])) {
+                    $n_rule_groups++;
+                    if ($value[0]['email_max_recipient'] > $maior_valor_regra_grupo)
+                        $maior_valor_regra_grupo = $value[0]['email_max_recipient'];
                 }
             }
-            if(!$erros_acumulados =='')
-            {
-                return $erros_acumulados;
-            }
-        }
-        else
-        {
-	    //Compatibilização com Outlook, ao encaminhar a mensagem
-			$body = mb_ereg_replace('<!--\[', '<!-- [', $params['body']);
-        }
-
-		$attachments = $_FILES;
-		$forwarding_attachments = $params['forwarding_attachments'];
-		$local_attachments = $params['local_attachments'];
-
-		//Test if must be saved in shared folder and change if necessary
-		if( $fromaddress[2] == 'y' ){
-			//build shared folder path
-			$newfolder = "user".$this->imap_delimiter.$fromaddress[3].$this->imap_delimiter.$this->imap_sentfolder;
-			if($this->folder_exists($newfolder)) 
-				$folder = $newfolder;
-			else 
-				$folder = $params['folder'];
-			
-		} else	{
-			$folder = $params['folder'];			
-		}
-		
-		$folder = mb_convert_encoding($folder, 'UTF7-IMAP','ISO_8859-1');
-		$folder = preg_replace('/INBOX[\/.]/i', 'INBOX'.$this->imap_delimiter, $folder);
-		$folder_name = $params['folder_name'];
-
-//		TODO - tratar assinatura e remover o AND false
-		if($signed && !$params['smime'] AND false)
-		{
-            $mail->Mailer = "smime";
-			$mail->SignedBody = true;
-		}
-
-
-		if($fromaddress)
-                	$mailService->setFrom ('"'.$fromaddress[0].'" <'.$fromaddress[1].'>');
-               else
-                	$mailService->setFrom ('"'.$_SESSION['phpgw_info']['expressomail']['user']['firstname'].' '.$_SESSION['phpgw_info']['expressomail']['user']['lastname'].'" <'.$_SESSION['phpgw_info']['expressomail']['user']['email'].'>');
-		//$mailService->addTo($toaddress);
-		//$mailService->addCc($ccaddress);
-		$bol = $this->add_recipients('to', $toaddress, $mailService);
-		if(!$bol){
-			return $this->parse_error("Invalid Mail:", $toaddress);
-		}
-		$bol = $this->add_recipients('cc', $ccaddress, $mailService);
-		if(!$bol){
-			return $this->parse_error("Invalid Mail:", $ccaddress);
-		}
-		$allow = $_SESSION['phpgw_info']['server']['expressomail']['allow_hidden_copy']; 
- 		 
-		if($allow) 
- 		                { 
-			//$mailService->addBcc($ccoaddress);
-			$bol = $this->add_recipients('cco', $ccoaddress, $mailService);
-
-			if(!$bol){
-				return $this->parse_error("Invalid Mail:", $ccoaddress);
-			}
-		}
-
-		//Implementação para o In-Reply-To e References				
-		$msg_numb = $params['messageNum'];
-		$msg_folder = $params['messageFolder'];
-		$this->mbox = $this->open_mbox($msg_folder);		
-	
-		$header = $this->get_header($msg_numb);
-		$header_ = imap_fetchheader($this->mbox, $msg_numb, FT_UID);
-		$pattern = '/^[ \t]*Disposition-Notification-To:[ ]*<?[[:alnum:]\._-]+@[[:alnum:]_-]+[\.[:alnum:]]+>?/sm';
-		if (preg_match($pattern, $header_, $fields))
-		{
-			if(preg_match('/[[:alnum:]\._\-]+@[[:alnum:]_\-\.]+/',$fields[0], $matches)){
-				$return['DispositionNotificationTo'] = "<".$matches[0].">";
-			}
-		}
-		
-		$message_id = $header->message_id;
-		$references = array();
-		if($message_id != "")
-		{
-                   $mailService->addHeaderField('In-Reply-To',$message_id);
-
-		   if(isset($header->references)){
-			array_push($references, $header->references);
-		   }		
-			array_push($references, $message_id);
-			$mailService->addHeaderField('References',$references);
-
-		}
-	
-
-		$mailService->setSubject($subject);
-		$isHTML = ( (array_key_exists('type', $params) && in_array(strtolower($params['type']), array('html', 'plain')) ) ? 
-						strtolower($params['type']) != 'plain' : true );
-	
-
-//		TODO - tratar mensagem criptografada e remover o AND false abaixo
-        if (($encrypt && $signed && $params['smime']) || ($encrypt && !$signed) AND false)	// a msg deve ser enviada cifrada...
-		{
-			$email = $this->add_recipients_cert($toaddress . ',' . $ccaddress. ',' .$ccoaddress);
-            $email = explode(",",$email);
-            // Deve ser testado se foram obtidos os certificados de todos os destinatarios.
-            // Deve ser verificado um numero limite de destinatarios.
-            // Deve ser verificado se os certificados sao validos.
-            // Se uma das verificacoes falhar, nao enviar o e-mail e avisar o usuario.
-            // O array $mail->Certs_crypt soh deve ser preenchido se os certificados passarem nas verificacoes.
-            $numero_maximo = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['num_max_certs_to_cipher'];  // Este valor dever ser configurado pelo administrador do site ....
-            $erros_acumulados = "";
-            $aux_mails = array();
-            $mail_list = array();
-            if(count($email) > $numero_maximo)
-            {
-                $erros_acumulados .= "Excedido o numero maximo (" . $numero_maximo . ") de destinatarios para uma msg cifrada...." . chr(0x0A);
-                return $erros_acumulados;
-            }
-            // adiciona o email do remetente. eh para cifrar a msg para ele tambem. Assim vai poder visualizar a msg na pasta enviados..
-            $email[] = $_SESSION['phpgw_info']['expressomail']['user']['email'];
-            foreach($email as $item)
-            {
-                $certificate = $db->get_certificate(strtolower($item));
-                if(!$certificate)
-                {
-                    $erros_acumulados .= "Chamada com parametro invalido.  e-Mail nao pode ser vazio." . chr(0x0A);
-                    return $erros_acumulados;
+
+            if ($default_max_size_rule) {
+                $size_rule = $db->get_rule_by_user($_SESSION['phpgw_info']['expressomail']['user']['userid']);
+
+                if (!$size_rule && $n_rule_groups == 0) /* O usuário não está em nenhuma regra por usuário nem por grupo. Vai usar a regra padrão. */ {
+                    if ($message_size_total > $default_max_size_rule)
+                        return $this->functions->getLang("Message size greateruler than allowed (Default rule)");
                 }
 
-                if (array_key_exists("dberr1", $certificate))
-                {
-
-                    $erros_acumulados .= "Ocorreu um erro quando pesquisava certificados dos destinatarios para cifrar a msg." . chr(0x0A);
-                    return $erros_acumulados;
-				}
-                if (array_key_exists("dberr2", $certificate))
-                {
-                    $erros_acumulados .=  $item . ' : Nao  pode cifrar a msg. Certificado nao localizado.' . chr(0x0A);
-                    //continue;
-                }
-			/*  Retirado este teste para evitar mensagem de erro duplicada.
-                if (!array_key_exists("certs", $certificate))
-              	{
-               		$erros_acumulados .=  $item . ' : Nao  pode cifrar a msg. Certificado nao localizado.' . chr(0x0A);
-                    continue;
-                }
-            */
-                include_once(dirname( __FILE__ ) ."/../../security/classes/CertificadoB.php");
-
-                foreach ($certificate['certs'] as $registro)
-                {
-                    $c1 = new certificadoB();
-                    $c1->certificado($registro['chave_publica']);
-                    if ($c1->apresentado)
-                    {
-                        $c2 = new Verifica_Certificado($c1->dados,$registro['chave_publica']);
-                        if (!$c1->dados['EXPIRADO'] && !$c2->revogado && $c2->status)
-                        {
-                            $aux_mails[] = $registro['chave_publica'];
-                            $mail_list[] = strtolower($item);
+                else {
+                    if (count($size_rule) > 0) /* Verifica se existe regra por usuário. Se houver, ela vai se sobresair das regras por grupo. */ {
+                        $regra_mais_permissiva = 0;
+                        foreach ($size_rule as $i => $value) {
+                            if ($regra_mais_permissiva < $value['email_max_recipient'])
+                                $regra_mais_permissiva = $value['email_max_recipient'];
                         }
-                        else
-                        {
-                            if ($c1->dados['EXPIRADO'] || $c2->revogado)
-                            {
-                                $db->update_certificate($c1->dados['SERIALNUMBER'],$c1->dados['EMAIL'],$c1->dados['AUTHORITYKEYIDENTIFIER'],
-                                    $c1->dados['EXPIRADO'],$c2->revogado);
-                            }
-
-                            $erros_acumulados .= $item . ':  ' . $c2->msgerro . chr(0x0A);
-                            foreach($c2->erros_ssl as $linha)
-                            {
-                                $erros_acumulados .=  $linha . chr(0x0A);
-                            }
-                            $erros_acumulados .=  'Emissor: ' . $c1->dados['EMISSOR'] . chr(0x0A);
-                            $erros_acumulados .=  $c1->dados['CRLDISTRIBUTIONPOINTS'] . chr(0x0A);
-                        }
+                        $regra_mais_permissiva = $regra_mais_permissiva * 1024 * 1024;
+                        if ($message_size_total > $regra_mais_permissiva)
+                            return $this->functions->getLang("Message size greater than allowed (Rule By User)");
                     }
-                    else
-                    {
-                        $erros_acumulados .= $item . ' : Nao  pode cifrar a msg. Certificado invalido.' . chr(0x0A);
+                    else /* Regra por grupo */ {
+                        $maior_valor_regra_grupo = $maior_valor_regra_grupo * 1024 * 1024;
+                        if ($message_size_total > $maior_valor_regra_grupo)
+                            return $this->functions->getLang("Message size greater than allowed (Rule By Group)");
                     }
                 }
-            	if(!(in_array(strtolower($item),$mail_list)) && !empty($erros_acumulados))
-				{
-					return $erros_acumulados;
-        		}
             }
-
-            $mail->Certs_crypt = $aux_mails;
-        }
-						
-		if( count($forwarding_attachments) > 0 )// Build CID images 
-			$this->buildEmbeddedImages($mailService,$msg_uid,$forwarding_attachments, $body); 
-
-		//	Build Uploading Attachments!!!
-		if (count($attachments)>0) //Caso seja forward normal...
-		{
-			$total_uploaded_size = 0;
-			foreach ($attachments as $attach)
-			{
-                                if($attach['error'] == UPLOAD_ERR_INI_SIZE)
-                                    return $this->parse_error("message file too big");
-				if($attach['name']=='Unknown')
-					continue;
-				$mailService->addFileAttachment($attach['tmp_name'], $attach['name'], $this->get_file_type($attach['name']), 'base64', 'attachment');
-				$total_uploaded_size = $total_uploaded_size + $attach['size'];
-			}
-                        if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['max_attachment_size'])
-                        {
-         
-                            $upload_max_filesize = str_replace('M','',$_SESSION['phpgw_info']['user']['preferences']['expressoMail']['max_attachment_size']) * 1024 * 1024;
-                            if( $total_uploaded_size > $upload_max_filesize)
-				return $this->parse_error("message file too big");
-			}
-		}
-		if(count($local_attachments)>0) { //Caso seja forward de mensagens locais
-
-			$total_uploaded_size = 0;
-			
-			foreach($local_attachments as $local_attachment) {
-				$file_description = unserialize(rawurldecode($local_attachment));
-				$tmp = array_values($file_description);
-				foreach($file_description as $i => $descriptor){
-					$tmp[$i]  = eregi_replace('\'*\'','',$descriptor);
-				}
-				$mailService->addFileAttachment($_FILES[$tmp[1]]['tmp_name'], $tmp[2], $this->get_file_type($tmp[2]), 'base64', 'attachment');
-				$total_uploaded_size = $total_uploaded_size + $_FILES[$tmp[1]]['size'];
-			}
-			if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['max_attachment_size'])
-                        {
-                            $upload_max_filesize = str_replace('M','',$_SESSION['phpgw_info']['user']['preferences']['expressoMail']['max_attachment_size']) * 1024 * 1024;
-                            if( $total_uploaded_size > $upload_max_filesize)
-                                   return $this->parse_error("message file too big");
-                        }
-		}
-
-		//	Build Forwarding Attachments!!!
-		if (count($forwarding_attachments) > 0)
-		{
-			// Bug fixed for array_search function
-			$name_cid_files = array(); 
-			if(count($name_cid_files) > 0) {
-				$name_cid_files[count($name_cid_files)] = $name_cid_files[0];
-				$name_cid_files[0] = null;
-			}
-
-			foreach($forwarding_attachments as $forwarding_attachment)
-			{
-				$file_description = unserialize(rawurldecode($forwarding_attachment));
-				
-				foreach($file_description as $i => $item)
-					$file_description[$i] = urldecode($item);
-				
-				$tmp = array_values($file_description);
-				foreach($file_description as $i => $descriptor){
-					$tmp[$i]  = eregi_replace('\'*\'','',$descriptor);
-				}
-				$file_description = $tmp;
-				$fileContent = $this->get_forwarding_attachment($file_description[0], $file_description[1], $file_description[3],$file_description[4]);
-				$fileName = $file_description[2];
-				if(!array_search(trim($fileName),$name_cid_files)) {
-					$filename_dec = html_entity_decode(rawurldecode($fileName));
-					$mailService->addStringAttachment($fileContent, $filename_dec, $this->get_file_type($file_description[2]), $file_description[4] );
-
-				}
-			}
-		}
-		
-		//Build Message Attachments!!!
-		if(count($message_attachments) > 0 ) 
-		{
-			foreach($message_attachments as $folder_name => $messages)
-			{
-				foreach ($messages as $message_number => $message_subject) 
-				{
-					if (!$message_subject)
-						$message_subject  = 'no title.eml';
-					else 
-						$message_subject .= '.eml';
-					
-					if( $message_attachments_contents &&  isset($message_attachments_contents[$folder_name]) )
-						$rawmsg = base64_decode( $message_attachments_contents[$folder_name][$message_number] );
-					else{
-						$mbox_stream = $this->open_mbox($folder_name);
-						$rawmsg = $this->getRawHeader($message_number) . "\r\n\r\n" . $this->getRawBody($message_number);
-					}
-							
-					$return_forward[] = array( 'name' => $message_subject, 'size' => mb_strlen($rawmsg));
-					$mailService->addStringAttachment($rawmsg, $message_subject, 'message/rfc822', '7bit', 'attachment' );
-				}
-			}
-		}
-		
-		$message_size_total += strlen($params['body']);   /* Tamanho do corpo da mensagem. */
-		$message_size_total += $total_uploaded_size;      /* Incrementa com os anexos da nova mensagem, se houver. */
-		
-		////////////////////////////////////////////////////////////////////////////////////////////////////	
-		/** 
-		* Faz a validação pelo tamanho máximo de mensagem permitido para o usuário. Se o usuário não estiver em nenhuma regra, usa o tamanho padrão.
-		 */
-		$default_max_size_rule = $db->get_default_max_size_rule();	
-		if(!$default_max_size_rule)
-		{
-			$default_max_size_rule = str_replace("M","",ini_get('upload_max_filesize')) * 1024 * 1024; /* hack para não bloquear o envio de email quando não for configurado um tamanho padrão */
-		}
-		else
-		{
-			foreach($default_max_size_rule as $i=>$value)
-			{		
-				$default_max_size_rule = $value['config_value'];
-			}				
-		}
-		
-		$default_max_size_rule = $default_max_size_rule * 1024 * 1024;		  /* Tamanho da regra padrão, em bytes */
-		$id_user = $_SESSION['phpgw_info']['expressomail']['user']['userid'];	
-		
-		
-		$ldap = new ldap_functions();
-		$groups_user = $ldap->get_user_groups($id_user);
-
-		$size_rule_by_group = array();	
-		foreach($groups_user as $k=>$value_)
-		{	
-			$rule_in_group = $db->get_rule_by_user_in_groups($k);
-			if ($rule_in_group != "")
-				array_push($size_rule_by_group, $rule_in_group);
-		}	
-		
-		$n_rule_groups = 0;
-		$maior_valor_regra_grupo = 0;
-		foreach($size_rule_by_group as $i=>$value)
-		{
-			if(is_array($value[0]))
-			{
-				$n_rule_groups++;
-				if($value[0]['email_max_recipient'] > $maior_valor_regra_grupo)
-					$maior_valor_regra_grupo = $value[0]['email_max_recipient'];
-			}
-		}
-		
-		if($default_max_size_rule)
-		{
-			$size_rule = $db->get_rule_by_user($_SESSION['phpgw_info']['expressomail']['user']['userid']);
-
-			if(!$size_rule && $n_rule_groups == 0) /* O usuário não está em nenhuma regra por usuário nem por grupo. Vai usar a regra padrão. */
-			{
-				if($message_size_total > $default_max_size_rule)
-					return $this->functions->getLang("Message size greateruler than allowed (Default rule)");
-			}
-
-			else 
-			{
-				if(count($size_rule) > 0) /* Verifica se existe regra por usuário. Se houver, ela vai se sobresair das regras por grupo. */
-				{
-					$regra_mais_permissiva = 0;
-					foreach($size_rule as $i=>$value)
-					{	
-						if($regra_mais_permissiva < $value['email_max_recipient'])
-							$regra_mais_permissiva = $value['email_max_recipient'];
-					}
-					$regra_mais_permissiva = $regra_mais_permissiva * 1024 * 1024;			
-					if($message_size_total > $regra_mais_permissiva)
-						return $this->functions->getLang("Message size greater than allowed (Rule By User)");
-				}
-				else /* Regra por grupo */
-				{		
-					$maior_valor_regra_grupo = $maior_valor_regra_grupo * 1024 * 1024;			
-					if($message_size_total > $maior_valor_regra_grupo)
-						return $this->functions->getLang("Message size greater than allowed (Rule By Group)");	
-				
-				
-				}
-			}
-		}
-		/** 
-         * Fim da validação do tamanho da regra do tamanho de mensagem.
-		 */
-		 ////////////////////////////////////////////////////////////////////////////////////////////////////
-		
-		
-		
-		
-		
-		if($isHTML)
-			$mailService->setBodyHtml($body);
-		else
-			$mailService->setBodyText($body);
-
-		if($is_important)
-			$mailService->addHeaderField('Importance','High');
-
-		if($return_receipt)
-			$mailService->addHeaderField('Disposition-Notification-To', $_SESSION['phpgw_info']['expressomail']['user']['email']);
-
-
-		if ($folder != 'null'){
-			$mbox_stream = $this->open_mbox($folder);
-			@imap_append($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, $mailService->getMessage(), "\\Seen");
-		}
-
-		$sent = $mailService->send();
-
-		if($sent !== true)
-		{
-   			return $this->parse_error($sent);
-		}
-		else
-		{
-            if ($signed && !$params['smime'])
-			{
-				return $sent;
-			}
-			if($_SESSION['phpgw_info']['server']['expressomail']['expressoMail_enable_log_messages'] == "True")
-			{
-				$userid = $_SESSION['phpgw_info']['expressomail']['user']['userid'];
-				$userip = $_SESSION['phpgw_info']['expressomail']['user']['session_ip'];
-				$now = date("d/m/y H:i:s");
-				$addrs = $toaddress.$ccaddress.$ccoaddress;
-				$sent = trim($sent);
-   				error_log("$now - $userip - $sent [$subject] - $userid => $addrs\r\n", 3, "/home/expressolivre/mail_senders.log");
-			}
-			if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_dynamic_contacts']) {
-				$contacts = new dynamic_contacts();
-				$new_contacts = $contacts->add_dynamic_contacts($toaddress.",".$ccaddress.",".$ccoaddress);
-				return array("success" => true, "new_contacts" => $new_contacts);
-			}
-   			return array("success" => true);
-		}
-	}
+            /**
+             * Fim da validação do tamanho da regra do tamanho de mensagem.
+             */
+            ////////////////////////////////////////////////////////////////////////////////////////////////////
+
+            if ($isHTML)
+                $mailService->setBodyHtml($body);
+            else
+                $mailService->setBodyText($body);
+
+            if ($is_important)
+                $mailService->addHeaderField('Importance', 'High');
+
+            if ($return_receipt)
+                $mailService->addHeaderField('Disposition-Notification-To', $_SESSION['phpgw_info']['expressomail']['user']['email']);
+
+
+            if ($folder != 'null') {
+                $mbox_stream = $this->open_mbox($folder);
+                @imap_append($mbox_stream, "{" . $this->imap_server . ":" . $this->imap_port . "}" . $folder, $mailService->getMessage(), "\\Seen");
+            }
+
+            $sent = $mailService->send();
+
+            if ($sent !== true) {
+                return $this->parse_error($sent);
+            } else {
+                if ($signed && !$params['smime']) {
+                    return $sent;
+                }
+                if ($_SESSION['phpgw_info']['server']['expressomail']['expressoMail_enable_log_messages'] == "True") {
+                    $userid = $_SESSION['phpgw_info']['expressomail']['user']['userid'];
+                    $userip = $_SESSION['phpgw_info']['expressomail']['user']['session_ip'];
+                    $now = date("d/m/y H:i:s");
+                    $addrs = $toaddress . $ccaddress . $ccoaddress;
+                    $sent = trim($sent);
+                    error_log("$now - $userip - $sent [$subject] - $userid => $addrs\r\n", 3, "/home/expressolivre/mail_senders.log");
+                }
+                if ($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_dynamic_contacts']) {
+                    $contacts = new dynamic_contacts();
+                    $new_contacts = $contacts->add_dynamic_contacts($toaddress . "," . $ccaddress . "," . $ccoaddress);
+                    return array("success" => true, "new_contacts" => $new_contacts);
+                }
+                
+                   if($params['uids_save'] )
+                        $this->delete_msgs(array('folder'=> $params['save_folder'] , 'msgs_number' => $params['uids_save']));
+                       
+                
+                return array("success" => true);
+                
+            }
+    }
 	
 	
-	/**
-	* @license   http://www.gnu.org/copyleft/gpl.html GPL
-	* @author    Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-	* @param     $mail email
-	* @param     $msg_uid uid da mensagem
-	* @param     $forwarding_attachments anexos
-	*/
-
-	function buildEmbeddedImages(&$mail,$msg_uid,&$forwarding_attachments ,&$body)
-	{ 
-		//Procura e retorna em $cids_imgs imagens embarcadas no corpo do e-mail
-		$pattern = '/src=("[^"]*?get_archive.php\?msgFolder=(.+)?&(amp;)?msgNumber=(.+)?&(amp;)?indexPart=(.+)?")/isU';
-		$cid_imgs = ''; 
-		preg_match_all( $pattern , $body , $cid_imgs , PREG_PATTERN_ORDER );
-		//-------------------------------------------------------------------//
-
-		$attPostions = array(); //Array que linka a possição da imagem com o indice que esta se encontra no array $forwarding_attachments
-
-		foreach ($forwarding_attachments as $i => $v){ // Monta o  array de link
-			$desc = unserialize(rawurldecode($v));
-			$attPostions[$desc[3]] = $i;
-		}
-
-		//Intera as imagens encontradas
-		foreach($cid_imgs[6] as $j => $val)
-        {		
-			$cid = base_convert(microtime().$j, 10, 36); //Gera um cid
-			$body = str_replace($cid_imgs[1][$j], '"cid:'.$cid.'"', $body ); //tira o src da imagem e coloca o cid.
-			$count    = strlen($cid_imgs[6][$j]);
-					
-			$attach_img = $forwarding_attachments[$attPostions['\''.$cid_imgs[6][$j].'\'']];
-			$file_description = unserialize(rawurldecode($attach_img));
-			
-			if (is_array($file_description))
-				foreach($file_description as $i => $descriptor)				
-                      $file_description[$i] = mb_ereg_replace('\'*\'','',$descriptor);
-
-			// The image is not in the same mail?
-			if ($msg_uid != $cid_imgs[4][$j]) 
-			{ 
-                $fa = $this->get_forwarding_attachment2($cid_imgs[2][$j], $cid_imgs[4][$j], $cid_imgs[6][$j], 'base64');
-                $fileContent = &$fa['binary'];
-				$fileName = $fa['name'];
-				$fileCode = $fa['encoding'];
-				$fileType =  $fa['type'];
-				$file_attached[0] = $cid_imgs[2][$j]; 
-				$file_attached[1] = $cid_imgs[4][$j]; 
-				$file_attached[2] = $fileName; 
-				$file_attached[3] = '0.'.(string)($j+1);
-				$file_attached[4] = 'base64'; 
-				$file_attached[5] = strlen($fileContent); //Size of file 
-				$file_attached[6] = $cid_imgs[6][$j];
-				$return_forward[] = $file_attached; 
-
- 				if ($file_attached[3] == $file_description[3] || $msg_uid == 'undefined')
-					unset($forwarding_attachments[$attPostions['\''.$cid_imgs[6][$j].'\'']]);
-				
-			} 
-			else 
-			{ 
-				$fileContent = $this->get_forwarding_attachment($file_description[0], $msg_uid, $file_description[3], 'base64'); 
-				$fileName = $file_description[2]; 
-				$fileCode = $file_description[4]; 
-				$file_description[3] = '0.'.(string)($j+1);
-				$file_description[6] = $cid_imgs[6][$j];
-				$fileType = $this->get_file_type($file_description[2]); 
-				unset($forwarding_attachments[$attPostions['\''.$cid_imgs[6][$j].'\'']]);
-				if (!empty($file_description)) 
-				{ 
-					$file_description[5] = strlen($fileContent); //Size of file 
-					$return_forward[] = $file_description; 
-				} 
-			} 
-
-			if ($fileContent) 
-				$mail->addStringImage($fileContent,$fileType,$fileName, $cid);					
-		}
-
-		return $return_forward; 
-	} 
 	function add_recipients_cert($full_address)
 	{
